// Program oblicza obwod i pole trojkata wg wzoru Herona
// autor: Piotr Grabowski

#include <iostream.h>  // strumienie we/wy
#include <stdlib.h>    // system
#include <math.h>      // sqrt

// Typ wyliczeniowy
enum relacja {FALSE, TRUE};

void pobierz_dane(double *bok_a, double *bok_b, double *bok_c);

class trojkat
{
	private:
		double a;
		double b;
		double c;
	public:
		trojkat(double, double, double); // Konstruktor klasy
		double obwod(void) const;        // metoda oblicza obwod
		double pole(void) const;         // metoda oblicza pole
		~trojkat();                      // Destruktor
};

// Konstruktor
trojkat::trojkat(double bok_a, double bok_b, double bok_c)
{
	a = bok_a;
	b = bok_b;
	c = bok_c;
}

double trojkat::obwod(void) const
{
	return (a + b + c);
}

double trojkat::pole(void) const
{
double pol_obw = obwod()/2;
	
	// wzor Herona
	return sqrt(pol_obw*(pol_obw - a)*(pol_obw - b)*(pol_obw - c));
}

trojkat::~trojkat(void)    // Destruktor
{
}

int main(void)
{
double bok_a, bok_b, bok_c;

	cout << " ----------------------------------------------------- \n";
	cout << " Program oblicza obwod i pole trojkata wg wzoru Herona \n";
	cout << " ----------------------------------------------------- \n\n";

	// Wyslij adresy pamieci
	pobierz_dane(&bok_a, &bok_b, &bok_c);
	
	// Utworz obiekt t1 klasy trojkat
	trojkat t1(bok_a, bok_b, bok_c);
	
	cout << "\n Obwod trojkata o podanych bokach wynosi:  ";
	cout << t1.obwod() << "\n";
	cout << " Pole trojkata jest rowne:                 ";
	cout << t1.pole()  << "\n\n";

	system("pause");
	return 0;
}

// Argumenty funkcji to wskazania na adresy pamieci
void pobierz_dane(double *bok_a, double *bok_b, double *bok_c)
{
relacja ok = FALSE;

	do
	{
		cout << "  Podaj bok a:  ";
		cin  >> *bok_a;
		cout << "  Podaj bok b:  ";
		cin  >> *bok_b;
		cout << "  Podaj bok c:  ";
		cin  >> *bok_c;
	
		if (*bok_a <= 0 || *bok_b <= 0 || *bok_c <= 0)
		{
			cout << "\n Przynajmniej jeden z podanych odcinkow jest niedodatni! \n";
			cout << " Sprobuj jeszcze raz... \n\n";
		}
		else if (*bok_a + *bok_b <= *bok_c ||
				 *bok_a + *bok_c <= *bok_b ||
				 *bok_b + *bok_c <= *bok_a)
		{
			cout << "\n Z tych odcinkow nie mozna zbudowac trojkata! \n";
			cout << " Sprobuj jeszcze raz... \n\n";
		}
		else ok = TRUE;

	} while (ok == FALSE);
}
