/* Uzycie standardowej funkcji sortujacej qsort */

#include <stdio.h>  /* printf, getchar */
#include <stdlib.h> /* qsort, exit, EXIT_SUCCESS, EXIT_FAILURE */

int porownaj(const void *arg1, const void *arg2);

typedef struct opis_znaku
{
	int wartosc_znaku;
	int czestosc;
} ZNAKI;

ZNAKI wystapienia[256]; /* Tablica czestosci wystapien */

int main(int argc, char *argv[])
{
int licznik, k, i;
FILE *zliczany;
int c;
	
	printf("Program zlicza ilosc wystapien kazdego znaku w podanym \n"
			"pliku oraz sortuje znaki wedlug czestosci wystapien \n\n");

	if (argc < 2)
	{
		printf("Uzycie: qsort <nazwa pliku> \n\n");
		printf("Nacisnij ENTER, aby zakonczyc program...");
		while (getchar() != '\n');
		exit(EXIT_FAILURE);
	}
	zliczany = fopen(argv[1], "rb");
	if (zliczany == NULL)
	{
		printf("Nie mozna otworzyc pliku %s! \n\n", argv[1]);
		printf("Nacisnij ENTER, aby zakonczyc program...");
		while (getchar() != '\n');
		exit(EXIT_FAILURE);
	}
	for (i = 0; i < 256; i++)
		wystapienia[i].wartosc_znaku = i;

	c = fgetc(zliczany);
	while (c != EOF)
	{
		licznik++;
		if (c >= ' ')
			wystapienia[c].czestosc++;
		c = fgetc(zliczany);
	}
	fclose(zliczany);
	printf("%d znakow w pliku \n\n", licznik);
	qsort(wystapienia, 256, sizeof(ZNAKI), porownaj);
	for (licznik = 0, k = 0; licznik < 256; licznik++)
	{
		if (wystapienia[licznik].czestosc != 0)
		{
			printf("%3c (%4d) = %d\n",
				wystapienia[licznik].wartosc_znaku,
				wystapienia[licznik].wartosc_znaku,
				wystapienia[licznik].czestosc);
			k++;			
			if (k%17 == 0)
			{
				printf("\n Nacisnij ENTER, aby kontynuowac... \n");
				while (getchar() != '\n');
				printf("\n\n\n\n");
			}
		}
	}
	printf("\n Nacisnij ENTER, aby zakonczyc program...");
	while (getchar() != '\n');
	return EXIT_SUCCESS;
}

int porownaj(const void *arg1, const void *arg2)
{
	ZNAKI *Arg1 = (ZNAKI *)arg1;
	ZNAKI *Arg2 = (ZNAKI *)arg2;
	/* Porownaj obie liczby */
	return (Arg2->czestosc - Arg1->czestosc);
}
